unit Complex;
// Complex number defintion and operations on it

interface
uses Transformation;

type
  TCplxNumber = record r,i:TFloat end;

// Result=a+b
function CplxAdd(a,b:TCplxNumber):TCplxNumber;
// Result=a-b
function CplxSub(a,b:TCplxNumber):TCplxNumber;
// Result=a*b
function CplxMul(a,b:TCplxNumber):TCplxNumber;

implementation

function CplxAdd;
begin
  Result.r:=a.r+b.r;
  Result.i:=a.i+b.i;
end;

function CplxSub;
begin
  Result.r:=a.r-b.r;
  Result.i:=a.i-b.i;
end;

function CplxMul;
begin
  Result.r:=a.r*b.r-a.i*b.i;
  Result.i:=a.r*b.i+a.i*b.r;
end;

end.
