unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, StdCtrls, ExtDlgs, ComCtrls, Shapes, Spin, Stats;

type
  TMainFrm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    LoadPicture1: TMenuItem;
    LoadMap1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Panel1: TPanel;
    Panel3: TPanel;
    Picture: TImage;
    Panel4: TPanel;
    Map: TImage;
    Label1: TLabel;
    Label2: TLabel;
    OpenPicture: TOpenPictureDialog;
    Open1: TMenuItem;
    Save1: TMenuItem;
    N2: TMenuItem;
    SaveDialog: TSaveDialog;
    OpenDialog: TOpenDialog;
    PicDrawArea: TImage;
    MapDrawArea: TImage;
    Splitter6: TSplitter;
    Shape1: TMenuItem;
    Select1: TMenuItem;
    N3: TMenuItem;
    Encode1: TMenuItem;
    Decode1: TMenuItem;
    N4: TMenuItem;
    EncodeAll1: TMenuItem;
    DecodeAll1: TMenuItem;
    N5: TMenuItem;
    ExportSpectrum1: TMenuItem;
    SaveCompDlg: TSaveDialog;
    Label30: TLabel;
    Label31: TLabel;
    SaveDecodedPicture1: TMenuItem;
    SaveDecodedDlg: TSaveDialog;
    N6: TMenuItem;
    Globalstatistics1: TMenuItem;
    About1: TMenuItem;
    OpenCompressedPicture1: TMenuItem;
    OpenCompDlg: TOpenDialog;
    ReconstPM: TPopupMenu;
    Clear1: TMenuItem;
    Save2: TMenuItem;
    Panel9: TPanel;
    Panel10: TPanel;
    Label3: TLabel;
    ShapeList: TListBox;
    Panel6: TPanel;
    ShowShBtn: TButton;
    DecAllBtn: TButton;
    EncAllBtn: TButton;
    ShowShapInfChck: TCheckBox;
    StopBtn: TButton;
    Splitter1: TSplitter;
    Panel2: TPanel;
    Splitter4: TSplitter;
    PageControl1: TPageControl;
    TabSheet4: TTabSheet;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    XLab: TLabel;
    YLab: TLabel;
    RWLab: TLabel;
    RHLab: TLabel;
    WLab: TLabel;
    HLab: TLabel;
    SlackLab: TLabel;
    IDLab: TLabel;
    Label13: TLabel;
    TSLab: TLabel;
    PCLab: TLabel;
    Label18: TLabel;
    Label20: TLabel;
    SpecAvalLab: TLabel;
    Label22: TLabel;
    IterDoneLab: TLabel;
    Label24: TLabel;
    CurrPSNRLab: TLabel;
    QuantLab: TLabel;
    Label25: TLabel;
    TabSheet1: TTabSheet;
    ViewDrawArea: TImage;
    TabSheet2: TTabSheet;
    Label4: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    PSNRLab: TLabel;
    Label16: TLabel;
    IteratLab: TLabel;
    EncoderLab: TLabel;
    EncProgBar: TProgressBar;
    ReqPSNREd: TEdit;
    EncBtn: TButton;
    ContEncChck: TCheckBox;
    Button1: TButton;
    TabSheet3: TTabSheet;
    Panel7: TPanel;
    Label19: TLabel;
    RedrawSpecBtn: TButton;
    ZoomSpin: TSpinEdit;
    ScrollBox1: TScrollBox;
    SpecDrawArea: TImage;
    TabSheet6: TTabSheet;
    Panel8: TPanel;
    Label21: TLabel;
    ZeroLab: TLabel;
    Label26: TLabel;
    NonZeroLab: TLabel;
    Label28: TLabel;
    MinValLab: TLabel;
    MaxValLab: TLabel;
    Label33: TLabel;
    CoefList: TListBox;
    TabSheet5: TTabSheet;
    DecodeBtn: TButton;
    ProgressBar: TProgressBar;
    Panel5: TPanel;
    Reconst: TImage;
    Label17: TLabel;
    ReconstDrawArea: TImage;
    Splitter7: TSplitter;
    Panel11: TPanel;
    Label23: TLabel;
    Log: TMemo;
    Splitter5: TSplitter;
    Label27: TLabel;
    N7: TMenuItem;
    SaveLog1: TMenuItem;
    SaveLogDlg: TSaveDialog;
    ClearLog1: TMenuItem;
    Map1: TMenuItem;
    Generategrid1: TMenuItem;
    MapPopup: TPopupMenu;
    Generaterectangles1: TMenuItem;
    SpecPM: TPopupMenu;
    SaveSpectrumPicture1: TMenuItem;
    ShapePM: TPopupMenu;
    MenuItem1: TMenuItem;
    SavePicture1: TMenuItem;
    SaveMap1: TMenuItem;
    Label29: TLabel;
    EncSpeedLab: TLabel;
    Label34: TLabel;
    NormTypeLab: TLabel;
    TabSheet7: TTabSheet;
    Label32: TLabel;
    NormCombo: TComboBox;
    RequantBtn: TButton;
    Panel12: TPanel;
    QuantQuality: TTrackBar;
    UseQSpecChck: TCheckBox;
    procedure LoadPicture1Click(Sender: TObject);
    procedure LoadMap1Click(Sender: TObject);
    procedure Panel2CanResize(Sender: TObject; var NewWidth,
      NewHeight: Integer; var Resize: Boolean);
    procedure Save1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure ShowShBtnClick(Sender: TObject);
    procedure MapDrawAreaMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MapDrawAreaClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EncBtnClick(Sender: TObject);
    procedure DecodeBtnClick(Sender: TObject);
    procedure RedrawSpecBtnClick(Sender: TObject);
    procedure ContEncChckClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure DecAllBtnClick(Sender: TObject);
    procedure EncAllBtnClick(Sender: TObject);
    procedure TabSheet1Show(Sender: TObject);
    procedure TabSheet5Resize(Sender: TObject);
    procedure UseQSpecChckClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Select1Click(Sender: TObject);
    procedure Encode1Click(Sender: TObject);
    procedure Decode1Click(Sender: TObject);
    procedure EncodeAll1Click(Sender: TObject);
    procedure DecodeAll1Click(Sender: TObject);
    procedure ExportSpectrum1Click(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure QuantQualityChange(Sender: TObject);
    procedure SaveDecodedPicture1Click(Sender: TObject);
    procedure TabSheet6Show(Sender: TObject);
    procedure Globalstatistics1Click(Sender: TObject);
    procedure ZoomSpinChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure OpenCompressedPicture1Click(Sender: TObject);
    procedure Clear1Click(Sender: TObject);
    procedure Save2Click(Sender: TObject);
    procedure Panel1Resize(Sender: TObject);
    procedure RequantBtnClick(Sender: TObject);
    procedure SaveLog1Click(Sender: TObject);
    procedure ClearLog1Click(Sender: TObject);
    procedure Generaterectangles1Click(Sender: TObject);
    procedure Generategrid1Click(Sender: TObject);
    procedure SaveSpectrumPicture1Click(Sender: TObject);
    procedure MenuItem1Click(Sender: TObject);
    procedure SavePicture1Click(Sender: TObject);
    procedure SaveMap1Click(Sender: TObject);
    procedure NormComboChange(Sender: TObject);
  private
    MDX, MDY : integer;
    currShape: TShape;
    currShapeIdx : integer;
    fStop:boolean;
    DecFillMap : TShapeMask;
    begIt : integer;
    iPicture : TPicData;
    iMap : TMapData;
    iPicW, iPicH, iMapW, iMapH : integer;
    StopProcess : boolean;
    SpeedTimeStamps : array [0..7] of TTime;
    SpeedTSPtr : byte;
    procedure ClearReconstArea;
    procedure CallBack(Iteration:integer; PSNR:real; Spectrum:TShapeData; Residue:TShapeData;
                           LastAddedX, LastAddedY:word; var Stop:boolean);
    { Private declarations }
  public
    procedure RefreshInfo;
    procedure WriteLog(s:string);
    { Public declarations }
  end;

var
  MainFrm: TMainFrm;

implementation
uses Math, EncSelFrm, Transformation, About, GenRect;
{$R *.DFM}

procedure TMainFrm.LoadPicture1Click(Sender: TObject);
var poms1,poms2:string[10];
    x,y,a:integer;
    r,g,b:byte;
    color:TColor;
    nonGray : boolean;
    pomr:TRect;
begin
  if OpenPicture.Execute then begin
    Picture.Picture.LoadFromFile(OpenPicture.FileName);
    iPicW:=Picture.Picture.Bitmap.Width;
    iPicH:=Picture.Picture.Bitmap.Height;
    PicDrawArea.Picture.Bitmap.Width:=iPicW;
    PicDrawArea.Picture.Bitmap.Height:=iPicH;
    SetLength(iPicture,iPicW*iPicH);
    a:=0;
    nonGray:=false;
    for y:=0 to iPicH-1 do
      for x:=0 to iPicW-1 do begin
        color:=Picture.Canvas.Pixels[x,y];
        r:=color and 255;
        g:=(color shr 8) and 255;
        b:=(color shr 16) and 255;
        nonGray:=nonGray or (r<>g) or (r<>b);
        iPicture[a]:= r;
        inc(a);
      end;
    if nonGray then begin
      WriteLog('Cann''t load picture. Picture is not grayscale image with 8bit color depth.'#13#10);
      SetLength(iPicture,0); iPicture:=nil;
      iPicH:=0; iPicW:=0;
      exit;
    end;
    pomr.Left:=0; pomr.Top:=0; pomr.Right:=iPicW-1; pomr.Bottom:=iPicH-1;
    PicDrawArea.Picture.Bitmap.TransparentColor:=MapDrawArea.Picture.Bitmap.TransparentColor;
    PicDrawArea.Canvas.Brush.Color:=PicDrawArea.Picture.Bitmap.TransparentColor;
    PicDrawArea.Canvas.FillRect(pomr);
    ClearReconstArea;
    str(iPicW,poms1);
    str(iPicH,poms2);
    WriteLog('Picture '+OpenPicture.FileName+' of size '+poms1+'x'+poms2+' loaded.'#13#10);
  end;
end;

function ToHex(value:longword):string;
begin
  Result:='';
  while value<>0 do begin
    if value and 15 < 10 then
      Result:=char((value and 15)+48)+Result
    else
      Result:=char((value and 15)+ord('A')-10)+Result;
    value:=value shr 4;
    if value and 15 < 10 then
      Result:=char((value and 15)+48)+Result
    else
      Result:=char((value and 15)+ord('A')-10)+Result;
    value:=value shr 4;
  end;
end;


procedure TMainFrm.LoadMap1Click(Sender: TObject);
var poms1,poms2:string[10];
    x,y,a,i:integer;
    besorolva:boolean;
    pomr:TRect;
begin
  if OpenPicture.Execute then begin
    Map.Picture.LoadFromFile(OpenPicture.FileName);
    iMapW:=Map.Picture.Bitmap.Width;
    iMapH:=Map.Picture.Bitmap.Height;
    MapDrawArea.Picture.Bitmap.Width:=iMapW;
    MapDrawArea.Picture.Bitmap.Height:=iMapH;
    SetLength(iMap,iMapW*iMapH);
    a:=0;
    for y:=0 to iMapH-1 do
      for x:=0 to iMapW-1 do begin
        iMap[a]:=Map.Canvas.Pixels[x,y];
        inc(a);
      end;
    str(Map.Picture.Width,poms1);
    str(Map.Picture.Height,poms2);
    WriteLog('Map '+OpenPicture.FileName+' of size '+poms1+'x'+poms2+' loaded.');
    WriteLog('Analyzing map file: locating shapes...');
    if (iPicture<>nil) and ((iMapW>iPicW) or (iMapH>iPicH)) then begin
       WriteLog('Error: height/width of map is larger than height/width of picture'#13#10);
       SetLength(iMap,0); iMap:=nil;
       iMapH:=0; iMapW:=0;
       exit;
    end;
    //Clear draw area
    pomr.Left:=0; pomr.Top:=0; pomr.Right:=iMapW-1; pomr.Bottom:=iMapH-1;
    MapDrawArea.Canvas.Brush.Color:=MapDrawArea.Picture.Bitmap.TransparentColor;
    MapDrawArea.Canvas.FillRect(pomr);
    //Destroy current shapes
    while ShapeList.Items.Count>0 do begin
      TShape(ShapeList.Items.Objects[0]).Destroy;
      ShapeList.Items.Delete(0);
    end;
    ProgressBar.Max:=iMapW*iMapH-1;
    ProgressBar.Position:=0;
    ProgressBar.Show;
    //Find new shapes
    a:=0;
    for y:=0 to iMapH-1 do begin
      for x:=0 to iMapW-1 do begin
        besorolva:=false;
        i:=ShapeList.Items.Count-1;
        while (i>=0) and not besorolva do begin
          besorolva:=TShape(ShapeList.Items.Objects[i]).AddPoint(iMap[a],X,Y);
          dec(i);
        end;
        if not besorolva then
          ShapeList.Items.AddObject('Shape '+ToHex(iMap[a]),TShape.Create(iMap[a], iPicture, iPicW, iMap, iMapW, X, Y));
        ProgressBar.Position:=y*iMapW+x;
        Application.ProcessMessages;
        inc(a);
      end;
    end;
    str(ShapeList.Items.Count,poms1);
    WriteLog(poms1+' shapes found. Done.'#13#10);
    ProgressBar.Hide;
    ClearReconstArea();
  end;
end;

procedure TMainFrm.Panel2CanResize(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
begin
  Resize:=NewWidth>30;
end;

procedure TMainFrm.Save1Click(Sender: TObject);
var s:TFileStream;
    poms1,poms2:string[10];
    i:integer;
begin
  if SaveDialog.Execute then begin
    WriteLog('Saving file '+SaveDialog.FileName+' ...');
    s:=TFileStream.Create(SaveDialog.FileName,fmCreate);
    s.Write('SAPC10'#13#10,8);
    Picture.Picture.Bitmap.SaveToStream(s);
    str(iPicW,poms1);
    str(iPicH,poms2);
    WriteLog('Picture of size '+poms1+'x'+poms2+' saved...');
    Map.Picture.Bitmap.SaveToStream(s);
    str(iMapW,poms1);
    str(iMapH,poms2);
    WriteLog('Map of size '+poms1+'x'+poms2+' saved...');
    i:=ShapeList.Items.Count;
    s.Write(i,sizeof(i));
    for i:=0 to ShapeList.Items.Count-1 do
      TShape(ShapeList.Items.Objects[i]).SaveToStream(s);
    str(ShapeList.Items.Count,poms1);
    WriteLog(poms1+' shapes saved.');
    s.Destroy;
  end;
end;

procedure TMainFrm.Open1Click(Sender: TObject);
var s:TFileStream;
    poms1,poms2:string[10];
    i:integer;
    pomsh:TShape;
    x,y,a:integer;
begin
  if OpenDialog.Execute then begin
    WriteLog('Opening file '+OpenDialog.FileName+' ...');
    s:=TFileStream.Create(OpenDialog.FileName,fmOpenRead);
    SetLength(poms1,8);
    s.Read(poms1[1],8);
    if (poms1='SIC1.0'#13#10) or (poms1='SAPC10'#13#10) then begin
      Picture.Picture.Bitmap.LoadFromStream(s);
      iPicW:=Picture.Picture.Bitmap.Width;
      iPicH:=Picture.Picture.Bitmap.Height;
      SetLength(iPicture,iPicW*iPicH);
      PicDrawArea.Picture.Bitmap.Width:=iPicW;
      PicDrawArea.Picture.Bitmap.Height:=iPicH;
      a:=0;
      for y:=0 to iPicH-1 do
        for x:=0 to iPicW-1 do begin
          iPicture[a]:=Picture.Picture.Bitmap.Canvas.Pixels[x,y] and 255;
          inc(a);
        end;
      str(iPicW,poms1);
      str(iPicH,poms2);
      WriteLog('Picture of size '+poms1+'x'+poms2+' loaded...');
      Map.Picture.Bitmap.LoadFromStream(s);
      iMapW:=Map.Picture.Bitmap.Width;
      iMapH:=Map.Picture.Bitmap.Height;
      SetLength(iMap,iMapW*iMapH);
      MapDrawArea.Picture.Bitmap.Width:=iMapW;
      MapDrawArea.Picture.Bitmap.Height:=iMapH;
      a:=0;
      for y:=0 to iMapH-1 do
        for x:=0 to iMapW-1 do begin
          iMap[a]:=Map.Picture.Bitmap.Canvas.Pixels[x,y];
          inc(a);
        end;
      ClearReconstArea;
      str(iMapW,poms1);
      str(iMapH,poms2);
      WriteLog('Map of size '+poms1+'x'+poms2+' loaded...');
      while ShapeList.Items.Count>0 do begin
        TShape(ShapeList.Items.Objects[0]).Destroy;
        ShapeList.Items.Delete(0);
      end;
      s.Read(i,sizeof(i));
      while i>0 do begin
        pomsh:=TShape.Create(0,iPicture, iPicW, iMap, iMapW, 0,0);
        pomsh.LoadFromStream(s);
        ShapeList.Items.AddObject('Shape '+toHex(pomsh.ID),pomsh);
        dec(i);
      end;
      str(ShapeList.Items.Count,poms1);
      WriteLog(poms1+' shapes loaded.'#13#10);
      ClearReconstArea();
  end else
    WriteLog('Error: incorrect input file format');
  s.Destroy;
  end;
end;

procedure TMainFrm.ShowShBtnClick(Sender: TObject);
var   pomr, pomsr:TRect;
      transcol:TColor;
begin
  if (ShapeList.Items.Count=0) or (ShapeList.ItemIndex<0) or (ShapeList.ItemIndex>=ShapeList.Items.Count) then exit;
  ShowShBtn.Enabled:=false;
  EncBtn.Enabled:=false;
  File1.Enabled:=false;
  DecodeBtn.Enabled:=false;
  WriteLog('Shape '''+ShapeList.Items.Strings[ShapeList.ItemIndex]+''' selected'#13#10'...analyzing it');
  currShapeIdx:=ShapeList.ItemIndex;
  currShape:=TShape(ShapeList.Items.Objects[currShapeIdx]);

  pomr.Left:=0; pomr.Top:=0; pomr.Right:=iMapW; pomr.Bottom:=iMapH;
  MapDrawArea.Picture.Bitmap.Canvas.Brush.Style:=bsSolid;
  transcol:=MapDrawArea.Picture.Bitmap.TransparentColor;
  MapDrawArea.Picture.Bitmap.Canvas.Brush.Color:=transcol;
  MapDrawArea.Picture.Bitmap.Canvas.FillRect(pomr);

  pomr.Left:=0; pomr.Top:=0; pomr.Right:=iPicW; pomr.Bottom:=iPicH;
  PicDrawArea.Picture.Bitmap.Canvas.Brush.Style:=bsSolid;
  PicDrawArea.Picture.Bitmap.Canvas.Brush.Color:=transcol;
  PicDrawArea.Picture.Bitmap.Canvas.FillRect(pomr);

  WriteLog('...drawing boundaries'); Application.ProcessMessages;
  currShape.Draw(PicDrawArea.Picture.Bitmap.Canvas,MapDrawArea.Picture.Bitmap.Canvas);
  MapDrawArea.Picture.Bitmap.TransparentColor:=transcol;
  PicDrawArea.Picture.Bitmap.TransparentColor:=transcol;

  // create view draw area
  WriteLog('...updating encoder input area'); Application.ProcessMessages;
  pomr.Left:=0; pomr.Top:=0; pomr.Right:=currShape.Width; pomr.Bottom:=currShape.Height;
  pomsr.Left:=currShape.Left; pomsr.Top:=currShape.Top; pomsr.Right:=pomsr.Left+pomr.Right; pomsr.Bottom:=pomsr.Top+pomr.Bottom;
  ViewDrawArea.Picture.Bitmap.Width:=pomr.Right;
  ViewDrawArea.Picture.Bitmap.Height:=pomr.Bottom;
  ViewDrawArea.Picture.Bitmap.Canvas.CopyMode:=cmSrcCopy;
  ViewDrawArea.Picture.Bitmap.Canvas.CopyRect(pomr,Picture.Picture.Bitmap.Canvas,pomsr);
  ViewDrawArea.Picture.Bitmap.Canvas.CopyMode:=cmSrcAnd;
  ViewDrawArea.Picture.Bitmap.Canvas.CopyRect(pomr,PicDrawArea.Picture.Bitmap.Canvas,pomsr);

  // create spectrum draw area
  RedrawSpecBtn.Click;

  RefreshInfo;

  WriteLog('Done.'#13#10);
  ShowShBtn.Enabled:=true;
  EncBtn.Enabled:=true;
  DecodeBtn.Enabled:=true;
  File1.Enabled:=true;
end;

procedure TMainFrm.MapDrawAreaMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  MDX:=Round((iMapW/MapDrawArea.Width)*X);
  MDY:=Round((iMapH/MapDrawArea.Height)*Y);
end;

procedure TMainFrm.MapDrawAreaClick(Sender: TObject);
var i:integer;
begin
  i:=0;
  while (i<ShapeList.Items.Count) and not TShape(ShapeList.Items.Objects[i]).MyPixel(MDX,MDY) do
    inc(i);
  if i<ShapeList.Items.Count then begin
    ShapeList.ItemIndex:=i;
    ShowShBtn.Click;
  end;
end;

procedure TMainFrm.FormCreate(Sender: TObject);
begin
  currShape:=nil;
  DecFillMap:=nil;
  iPicture:=nil; iMap:=nil;
  iPicW:=0; iPicH:=0; iMapW:=0; iMapH:=0;
  SpeedTSPtr:=0; SpeedTimeStamps[7]:=0;
  NormCombo.ItemIndex:=2;
end;

procedure TMainFrm.CallBack(Iteration:integer; PSNR:real; Spectrum:TShapeData; Residue:TShapeData;
                           LastAddedX, LastAddedY:word; var Stop:boolean);
var poms:string[10];
begin
  SpeedTimeStamps[SpeedTSPtr]:=Time;
  if (SpeedTimeStamps[7]<>0) and (SpeedTimeStamps[SpeedTSPtr]<>SpeedTimeStamps[(SpeedTSPtr+1) and 7]) then
    str(8*currShape.Width*currShape.Height/((SpeedTimeStamps[SpeedTSPtr]-SpeedTimeStamps[(SpeedTSPtr+1) and 7])*86400):0:0,poms)
  else if (SpeedTSPtr<>0) and (SpeedTimeStamps[SpeedTSPtr]<>SpeedTimeStamps[0]) then
    str((SpeedTSPtr+1)*currShape.Width*currShape.Height/((SpeedTimeStamps[SpeedTSPtr]-SpeedTimeStamps[0])*86400):0:0,poms)
  else poms:='';
  EncSpeedLab.Caption:=poms;
  SpeedTSPtr:=(SpeedTSPtr+1) and 7;
  if (Iteration-begIt<3) and (Round(100*PSNR)<=MainFrm.EncProgBar.Max) then MainFrm.EncProgBar.Min:=Round(100*PSNR);
  if Round(100*PSNR)<=MainFrm.EncProgBar.Max then MainFrm.EncProgBar.Position:=Round(100*PSNR);
  str(PSNR:0:2,poms);
  MainFrm.PSNRLab.Caption:=poms;
  str(Iteration,poms);
  MainFrm.IteratLab.Caption:=poms;
  if MainFrm.ShowShapInfChck.Checked then
    MainFrm.SpecDrawArea.Canvas.Pixels[LastAddedX,LastAddedY]:=Round(Spectrum[MainFrm.currShape.Width*LastAddedY+LastAddedX]);
  Application.ProcessMessages;
  Stop:=fStop;
end;

procedure TMainFrm.EncBtnClick(Sender: TObject);
var req:real;
    code:integer;
    poms:string[10];
begin
  if currShape=nil then exit;
  if EncBtn.Caption='Encode' then begin
    val(ReqPSNREd.Text,req,code);
    if code<>0 then begin
      WriteLog('Error: '+ReqPSNREd.Text+' not a correct floating point number'#13#10);
      exit;
    end;
    fStop:=false;
    if currShape<>nil then begin
      WriteLog('Transformation of '+ShapeList.Items.Strings[currShapeIdx]+' started...');
      WriteLog('...using transformation '+EncSelForm.TransName);
      if currShape.HaveSpectrum and ContEncChck.Checked then begin
        str(currShape.IterationsDone,poms); IteratLab.Caption:=poms;
        str(currShape.CurrentPSNR:0:2,poms); PSNRLab.Caption:=poms;
        WriteLog('...continue transforming from '+IteratLab.Caption+'. iteration ['+PSNRLab.Caption+' dB]');
      end;
      EncBtn.Caption:='Stop';
      ShowShBtn.Enabled:=false;
      File1.Enabled:=false;
      DecodeBtn.Enabled:=false;
      EncProgBar.Min:=0;
      EncProgBar.Max:=Round(100*req);
      begIt:=(currShape.IterationsDone)* ord(currShape.HaveSpectrum and ContEncChck.Checked);
      try
        if (currShape.TransModuleID=0) and (currShape.TransformationID=0) or EncSelForm.ForceDefModule.Checked then
          currShape.Encode(EncSelForm.DefModule,EncSelForm.DefTrans,req, currShape.HaveSpectrum and ContEncChck.Checked,1,CallBack)
        else
          currShape.Encode(EncSelForm.SelModule,EncSelForm.SelTrans,req, currShape.HaveSpectrum and ContEncChck.Checked,1,CallBack);
      except
        on E:Exception do
          WriteLog('Exception at transforming shape: '+E.Message);
      end;
      currShape.QuantQuality:=QuantQuality.Position*ord(UseQSpecChck.Checked);
      EncProgBar.Position:=EncProgBar.Min;
      EncBtn.Caption:='Encode';
      if not fStop then WriteLog('Transformation complete. Done.'#13#10);
      RefreshInfo;
      ShowShBtn.Enabled:=true;
      File1.Enabled:=true;
      DecodeBtn.Enabled:=true;
      if ShowShapInfChck.Checked then RedrawSpecBtn.Click;
    end;
  end else begin
    WriteLog('process cancelled by user. Done.'#13#10);
    fStop:=true;
  end;
end;

procedure TMainFrm.DecodeBtnClick(Sender: TObject);
begin
  if currShape=nil then exit;
  WriteLog('Decoding of shape '+ShapeList.Items.Strings[currShapeIdx]+' started...');
  if not currShape.HaveSpectrum then begin
    WriteLog('Unable to decode shape: no spectrum data available'#13#10);
    exit
  end;
  ShowShBtn.Enabled:=false;
  File1.Enabled:=false;
  DecodeBtn.Enabled:=false;
  WriteLog('...transforming spectrum...rado :-)');
  if currShape.Decode(Reconst.Picture.Bitmap.Canvas,DecFillMap) then begin
    WriteLog('...drawing boundaries');
    ReconstDrawArea.Picture.Assign(PicDrawArea.Picture);
    WriteLog('Done.'#13#10);
  end else begin
    WriteLog('Unable to decode shape'#13#10);
  end;
  ShowShBtn.Enabled:=true;
  File1.Enabled:=true;
  DecodeBtn.Enabled:=true;
end;

procedure TMainFrm.RedrawSpecBtnClick(Sender: TObject);
var
    Spec:TSpecData;
    i:integer;
    min,max:integer;
    zero, nonzero:integer;
    poms:string[10];
begin
  if currShape=nil then exit;
  WriteLog('...updating spectrum view for '+ShapeList.Items.Strings[currShapeIdx]); Application.ProcessMessages;
  SpecDrawArea.Picture.Bitmap.Width:=currShape.Width;
  SpecDrawArea.Picture.Bitmap.Height:=currShape.Height;
  SpecDrawArea.Width:=ZoomSpin.Value*currShape.Width;
  SpecDrawArea.Height:=ZoomSpin.Value*currShape.Height;
  SpecDrawArea.Picture.Bitmap.PixelFormat:=pf24bit;
  currShape.DrawSpectrum(SpecDrawArea.Picture.Bitmap.Canvas);
  min:=2147483647;
  max:=-2147483647;
  zero:=0; nonzero:=0;
  CoefList.Clear;
  for i:=0 to currShape.GetSpectrumStream(Spec)-1 do begin
    if Spec[i]=0 then inc(zero)
    else inc(nonzero);
    if Spec[i]>max then max:=Spec[i];
    if Spec[i]<min then min:=Spec[i];
    if Spec[i]<>0 then begin
      str(Spec[i],poms);
      CoefList.Items.Add(poms);
    end;
  end;
  SetLength(Spec,0); Spec:=nil;
  str(zero,poms); ZeroLab.Caption:=poms;
  str(nonzero,poms); NonZeroLab.Caption:=poms;
  if min<2147483647 then str(min,poms) else poms:='';
  MinValLab.Caption:=poms;
  if max>-2147483647 then str(max,poms) else poms:='';
  MaxValLab.Caption:=poms;
  WriteLog('Done.'#13#10);
end;

procedure TMainFrm.ClearReconstArea;
var
    pomr:TRect;
begin
  Reconst.Picture.Bitmap.Width:=iMapW;
  Reconst.Picture.Bitmap.Height:=iMapH;
  ReconstDrawArea.Picture.Bitmap.Width:=iMapW;
  ReconstDrawArea.Picture.Bitmap.Height:=iMapH;
  Reconst.Picture.Bitmap.PixelFormat:=pf24bit;
  pomr.Left:=0; pomr.Top:=0; pomr.Right:=iMapW-1; pomr.Bottom:=iMapH-1;
  Reconst.Picture.Bitmap.TransparentColor:=MapDrawArea.Picture.Bitmap.TransparentColor;
  Reconst.Canvas.Brush.Color:=Reconst.Picture.Bitmap.TransparentColor;
  Reconst.Canvas.FillRect(pomr);
  ReconstDrawArea.Picture.Bitmap.TransparentColor:=MapDrawArea.Picture.Bitmap.TransparentColor;
  ReconstDrawArea.Canvas.Brush.Color:=PicDrawArea.Picture.Bitmap.TransparentColor;
  ReconstDrawArea.Canvas.FillRect(pomr);
  SetLength(DecFillMap,iMapW*iMapH);
  FillChar(DecFillMap[0],iMapW*iMapH,ord(false));
end;

procedure TMainFrm.RefreshInfo;
var   poms:string[20];
      T : PTransformation;
begin
  with currShape do begin
    str(Left,poms); XLab.Caption:=poms;
    str(Top,poms); YLab.Caption:=poms;
    str(RealWidth,poms); RWLab.Caption:=poms;
    str(RealHeight,poms); RHLab.Caption:=poms;
    str(Width,poms); WLab.Caption:=poms;
    str(Height,poms); HLab.Caption:=poms;
    str((100*(Width*Height-RealWidth*RealHeight))/(Width*Height):0:2,poms); SlackLab.Caption:=poms+' %';
    str((100*(Width*Height-PointCount))/(Width*Height):0:2,poms); TSLab.Caption:=poms+' %';
    str(ID,poms); IDLab.Caption:=poms;
    str(PointCount,poms); PCLab.Caption:=poms;
    if HaveSpectrum then SpecAvalLab.Caption:='Yes' else SpecAvalLab.Caption:='No';
    str(IterationsDone,poms); IterDoneLab.Caption:=poms;
    str(CurrentPSNR:0:2,poms); CurrPSNRLab.Caption:=poms;
    if QuantQuality=0 then QuantLab.Caption:='Not quantized'
    else begin
      str(QuantQuality,poms); QuantLab.Caption:=poms;
    end;
    case NormType of
      0: NormTypeLab.Caption:='None';
      1: NormTypeLab.Caption:='Orthogonal';
      2: NormTypeLab.Caption:='Orthonormal';
      3: NormTypeLab.Caption:='8*Orthogonal';
      4: NormTypeLab.Caption:='64*Orthogonal';
    end;
    NormCombo.ItemIndex:=NormType;
    ContEncChck.Visible:=HaveSpectrum; ContEncChckClick(self);
    T:=EncSelFrm.FindTransformation(TransModuleID,TransformationID);
    if T=nil then EncoderLab.Caption:='<Codec not selected or found>'
    else EncoderLab.Caption:=T.Name;
  end;
end;

procedure TMainFrm.ContEncChckClick(Sender: TObject);
begin
  if ContEncChck.Checked then begin
    IteratLab.Caption:=IterDoneLab.Caption;
    PSNRLab.Caption:=CurrPSNRLab.Caption;
  end else begin
    IteratLab.Caption:='0';
    PSNRLab.Caption:='0';
  end;
end;

procedure TMainFrm.FormDestroy(Sender: TObject);
begin
  SetLength(DecFillMap,0); DecFillMap:=nil;
end;

procedure TMainFrm.DecAllBtnClick(Sender: TObject);
var i:integer;
    poms:string[10];
    pomr:TRect;
begin
  DecAllBtn.Enabled:=false;
  EncAllBtn.Enabled:=false;
  ClearReconstArea;
  str(ShapeList.Items.Count,poms);
  WriteLog('Start decoding '+poms+' shapes');
  pomr.Left:=0; pomr.Top:=0; pomr.Right:=iPicW-1; pomr.Bottom:=iPicH-1;
  PicDrawArea.Picture.Bitmap.TransparentColor:=MapDrawArea.Picture.Bitmap.TransparentColor;
  PicDrawArea.Canvas.Brush.Color:=PicDrawArea.Picture.Bitmap.TransparentColor;
  PicDrawArea.Canvas.FillRect(pomr);
  pomr.Left:=0; pomr.Top:=0; pomr.Right:=iMapW-1; pomr.Bottom:=iMapH-1;
  MapDrawArea.Canvas.Brush.Color:=MapDrawArea.Picture.Bitmap.TransparentColor;
  MapDrawArea.Canvas.FillRect(pomr);
  StopBtn.Visible:=true;
  StopProcess:=false; i:=0;
  while (i<ShapeList.Items.Count) and not StopProcess do begin
    if ShowShapInfChck.Checked then begin
      ShapeList.ItemIndex:=i;
      ShowShBtn.Click;
    end else begin
      currShape:=TShape(ShapeList.Items.Objects[i]);
      currShapeIdx:=i;
      RefreshInfo;
    end;
    DecodeBtn.Click;
    Application.ProcessMessages;
    inc(i);
  end;
  StopBtn.Visible:=false;
  str(i,poms);
  WriteLog(poms+' shapes decoded'#13#10);
  DecAllBtn.Enabled:=true;
  EncAllBtn.Enabled:=true;
end;

procedure TMainFrm.EncAllBtnClick(Sender: TObject);
var i:integer;
    poms:string[10];
    pomr:TRect;
begin
  DecAllBtn.Enabled:=false;
  EncAllBtn.Enabled:=false;
  str(ShapeList.Items.Count,poms);
  WriteLog('Start encoding '+poms+' shapes');
  pomr.Left:=0; pomr.Top:=0; pomr.Right:=iPicW-1; pomr.Bottom:=iPicH-1;
  PicDrawArea.Picture.Bitmap.TransparentColor:=MapDrawArea.Picture.Bitmap.TransparentColor;
  PicDrawArea.Canvas.Brush.Color:=PicDrawArea.Picture.Bitmap.TransparentColor;
  PicDrawArea.Canvas.FillRect(pomr);
  pomr.Left:=0; pomr.Top:=0; pomr.Right:=iMapW-1; pomr.Bottom:=iMapH-1;
  MapDrawArea.Canvas.Brush.Color:=MapDrawArea.Picture.Bitmap.TransparentColor;
  MapDrawArea.Canvas.FillRect(pomr);
  StopProcess:=false; i:=0;
  StopBtn.Visible:=true;
  while (i<ShapeList.Items.Count) and not StopProcess do begin
    if ShowShapInfChck.Checked then begin
      ShapeList.ItemIndex:=i;
      ShowShBtn.Click;
    end else begin
      currShape:=TShape(ShapeList.Items.Objects[i]);
      currShapeIdx:=i;
      RefreshInfo;
    end;
    EncBtn.Click;
    Application.ProcessMessages;
    inc(i);
  end;
  StopBtn.Visible:=false;
  str(i,poms);
  WriteLog(poms+' shapes encoded'#13#10);
  DecAllBtn.Enabled:=true;
  EncAllBtn.Enabled:=true;
end;

procedure TMainFrm.TabSheet1Show(Sender: TObject);
begin
  ViewDrawArea.Width:=15;
end;

procedure TMainFrm.TabSheet5Resize(Sender: TObject);
begin
  QuantQuality.Width:=TabSheet5.ClientWidth;
end;

procedure TMainFrm.UseQSpecChckClick(Sender: TObject);
begin
  QuantQuality.Enabled:=UseQSpecChck.Checked;
  if currShape=nil then exit;
  currShape.QuantQuality:=QuantQuality.Position*ord(UseQSpecChck.Checked);
  RefreshInfo;
  RedrawSpecBtn.Click;
end;

procedure TMainFrm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TMainFrm.Select1Click(Sender: TObject);
begin
  if ShowShBtn.Enabled then ShowShBtn.Click;
end;

procedure TMainFrm.Encode1Click(Sender: TObject);
begin
  if EncBtn.Enabled then EncBtn.Click;
end;

procedure TMainFrm.Decode1Click(Sender: TObject);
begin
  if DecodeBtn.Enabled then DecodeBtn.Click;
end;

procedure TMainFrm.EncodeAll1Click(Sender: TObject);
begin
  if EncAllBtn.Enabled then EncAllBtn.Click;
end;

procedure TMainFrm.DecodeAll1Click(Sender: TObject);
begin
  if DecAllBtn.Enabled then DecAllBtn.Click;
end;


type
  TWCData = class
    Value:integer;
    Count:longword;
    Range : longword;
    AbsIDX : integer;
    AbsData : integer;
    constructor Create(pValue,pAbsIDX,pAbsData:integer);
  end;

constructor TWCData.Create;
begin
  Value:=pValue;
  AbsIDX:=pAbsIDX;
  AbsData:=pAbsData;
  Count:=1;
end;

procedure TMainFrm.ExportSpectrum1Click(Sender: TObject);
var
    i,j,L,R:integer;
    f:TFileStream;
    Shape : TShape;
    useCommonConfig : boolean;
    tmpS : TMemoryStream;
    Data:TSpecData;
    Count:integer;
    TotalRange : longword;
    ValueTable:TList;
    srcPtr:integer;
    a,b,ax,bx:longword;
    s:int64;
    Buffer:longword;
    SF:byte;
    Underflows:byte;
    Encoded : boolean;
    tmpShort : shortint;
    tmpByte : byte;
    tmpWord : word;

  procedure WriteBit(bit:longword);
  begin
    Buffer:=(Buffer shl 1) or ord(bit<>0);
    dec(SF);
    if SF=0 then begin f.Write(Buffer,4); SF:=32; Buffer:=0 end;
  end;

begin
  if ShapeList.Items.Count=0 then exit;
  i:=ShapeList.Items.Count-1;
  while (i>=0) and TShape(ShapeList.Items.Objects[i]).HaveSpectrum  do dec(i);
  if i>=0 then begin WriteLog('Can''t compress picture, because isn''t available spectrum for all shapes. Transform all shapes first!'); exit end;
  if SaveCompDlg.Execute then begin
    WriteLog('Saving spectrum...');
    //create file
    f:=TFileStream.Create(SaveCompDlg.FileName,fmCreate);
    //write file format ID
    f.Write('SAPF11',6);
    //check, whether every shape has the same configuration
    Shape:=TShape(ShapeList.Items.Objects[0]);
    i:=1;
    while (i<ShapeList.Items.Count) and
          (TShape(ShapeList.Items.Objects[i]).TransModuleID=Shape.TransModuleID) and
          (TShape(ShapeList.Items.Objects[i]).TransformationID=Shape.TransformationID) and
          (TShape(ShapeList.Items.Objects[i]).QuantQuality=Shape.QuantQuality) do inc(i);
    useCommonConfig:=i=ShapeList.Items.Count;
    f.Write(UseCommonConfig,sizeof(UseCommonConfig));
    //if common config is used, write them
    if UseCommonConfig then begin
      f.Write(Shape.TransModuleID, sizeof(Shape.TransModuleID));
      f.Write(Shape.TransformationID, sizeof(Shape.TransformationID));
      f.Write(Shape.QuantQuality, sizeof(Shape.QuantQuality));
      f.Write(Shape.NormType, sizeof(Shape.NormType));
    end;

    WriteLog('...analyzing data and bulding statistics');
    //Generate statistics for compression
    tmpS:=TMemoryStream.Create;
    //Create value table
    ValueTable:=TList.Create;
    //Add End of block symbol
    ValueTable.Add(TWCData.Create(-32768,0,0));
    TWCData(ValueTable.Items[0]).Count:=0;
    ValueTable.Add(TWCData.Create(0,1,1));
    TWCData(ValueTable.Items[1]).Count:=0;
    for i:=0 to ShapeList.Items.Count-1 do begin
      Application.ProcessMessages;
      Shape:=TShape(ShapeList.Items.Objects[i]);
      Count:=Shape.GetSpectrumStream(Data);
      if not useCommonConfig then begin
        SetLength(Data,Count+4);
        Move(Data[0],Data[4],Count*sizeof(Data[0]));
        Data[0]:=integer(Shape.TransModuleID);
        Data[1]:=integer(Shape.TransformationID);
        Data[2]:=integer(Shape.QuantQuality);
        Data[3]:=integer(Shape.NormType);
        inc(Count,4);
      end;

      for srcPtr:=0 to Count-1 do begin
        //Find value in value list or add it if not exists
        if Data[srcPtr]=0 then j:=1
        else begin
          L:=1; R:=ValueTable.Count;
          j:=(L+R) div 2;
          while (L<R-1) do
            if TWCData(ValueTable.Items[j]).Value<Data[srcPtr] then begin
              L:=j;
              j:=(L+R) div 2;
            end else if TWCData(ValueTable.Items[j]).Value>Data[srcPtr] then begin
              R:=j;
              j:=(L+R) div 2;
            end else begin R:=j; L:=j end;
          j:=R;
        end;
        if (j=ValueTable.Count) or (TWCData(ValueTable.Items[j]).Value<>Data[srcPtr]) then begin
          for L:=0 to ValueTable.Count-1 do
            if TWCData(ValueTable.Items[L]).AbsData>=j then
              inc(TWCData(ValueTable.Items[L]).AbsData);
          if j<ValueTable.Count then L:=TWCData(ValueTable.Items[j]).AbsData
          else L:=j;
          ValueTable.Insert(j,TWCData.Create(Data[srcPtr],ValueTable.Count,L));
          for L:=j+1 to ValueTable.Count-2 do
            TWCData(ValueTable.Items[L]).AbsData:=TWCData(ValueTable.Items[L+1]).AbsData;
          TWCData(ValueTable.Items[ValueTable.Count-1]).AbsData:=j;
        end else
          TWCData(ValueTable.Items[j]).Count:=TWCData(ValueTable.Items[j]).Count+1;
        tmpS.Write(TWCData(ValueTable.Items[j]).AbsIDX,sizeof(TWCData(ValueTable.Items[j]).AbsIDX));
      end;
      //write EOB
      j:=0;
      TWCData(ValueTable.Items[j]).Count:=TWCData(ValueTable.Items[j]).Count+1;
      tmpS.Write(j,sizeof(j));
    end;
    //write EOB (symbols [0][EOB])
    j:=1;
    TWCData(ValueTable.Items[j]).Count:=TWCData(ValueTable.Items[j]).Count+1;
    tmpS.Write(j,sizeof(j));
    j:=0;
    TWCData(ValueTable.Items[j]).Count:=TWCData(ValueTable.Items[j]).Count+1;
    tmpS.Write(j,sizeof(j));
    SetLength(Data,0); Data:=nil;

    //Compute ranges
    TWCData(ValueTable.Items[0]).Range:=0;
    for i:=1 to ValueTable.Count-1 do
      TWCData(ValueTable.Items[i]).Range:=TWCData(ValueTable.Items[i-1]).Range+TWCData(ValueTable.Items[i-1]).Count;

    //write statistics table to output file
    f.Write(ValueTable.Count, sizeof(ValueTable.Count));
    //write range for symbol 0
    for i:=0 to ValueTable.Count-1 do begin
      Application.ProcessMessages;
      if i>1 then begin
        j:=TWCData(ValueTable.Items[i]).Value-TWCData(ValueTable.Items[i-1]).Value;
        if (j<-65535-128) or (j>65535+127) then WriteLog('Internal codec error. Cannot write symbol table for arithmetic codec. Number can''t fit to reserved bits');
        if (j>-128) and (j<127) then begin
          tmpShort:=j;
          f.Write(tmpShort,sizeof(tmpShort));
        end else begin
          if j<=-128 then begin tmpShort:=-128; tmpWord:=-j+128; end
          else if j>=127 then begin tmpShort:=127; tmpWord:=j-127 end;
          f.Write(tmpShort,sizeof(tmpShort));
          f.Write(tmpWord,sizeof(tmpWord));
        end;
      end;
      if i=1 then
        f.Write(TWCData(ValueTable.Items[i]).Count,sizeof(TWCData(ValueTable.Items[i]).Count))
      else begin
        tmpWord:=TWCData(ValueTable.Items[i]).Count;
        if (tmpWord<255) then begin
          tmpByte:=tmpWord;
          f.Write(tmpByte,sizeof(tmpByte));
        end else begin
          tmpByte:=255; tmpWord:=tmpWord-255;
          f.Write(tmpByte,sizeof(tmpByte));
          f.Write(tmpWord,sizeof(tmpWord));
        end;
      end;
    end;

    WriteLog('...compressing spectrum');
    //Encode
    Buffer:=0; SF:=32; Underflows:=0;
    a:=0; b:=$FFFFFFFF;
    TotalRange:=TWCData(ValueTable.Items[ValueTable.Count-1]).Range+TWCData(ValueTable.Items[ValueTable.Count-1]).Count;
    tmpS.Seek(0,soFromBeginning);
    while tmpS.Position<tmpS.Size do begin
      Application.ProcessMessages;
      tmpS.Read(i,sizeof(i)); i:=TWCData(ValueTable.Items[i]).AbsData;
      ax:=TWCData(ValueTable.Items[i]).Range;
      if i<ValueTable.Count-1 then bx:=TWCData(ValueTable.Items[i+1]).Range
      else bx:=TotalRange;

      s:=int64(b)-a+1;
      b:=int64(a)+(s*bx) div TotalRange -1;
      a:=int64(a)+(s*ax) div TotalRange;
      Encoded := false;
      while not Encoded do
        if (a and $80000000 = b and $80000000) then begin
          WriteBit(b and $80000000);
          while Underflows>0 do begin WriteBit((not b) and $80000000); dec(Underflows); end;
          a:=a shl 1;
          b:=(b shl 1) or 1;
        end
        else if (a and $40000000<>0) and (b and $40000000=0) then begin
          inc(Underflows);
          a:=(a and $3fffffff) shl 1;
          b:=((b or $40000000) shl 1) or 1;
        end
        else Encoded:=true;
      end;

    //Flush buffers
    WriteBit(a and $40000000);
    inc(Underflows);
    while Underflows>0 do begin WriteBit((not a) and $40000000); dec(Underflows); end;
    while SF<32 do WriteBit(0);

    //destory structures
    while ValueTable.Count>0 do begin
      TWCData(ValueTable.Items[0]).Destroy;
      ValueTable.Delete(0);
    end;
    ValueTable.Destroy;
    tmpS.Destroy;
    f.Destroy;
    WriteLog('...Done.'#13#10);
  end;
end;

procedure TMainFrm.StopBtnClick(Sender: TObject);
begin
  StopProcess:=true;
end;

procedure TMainFrm.QuantQualityChange(Sender: TObject);
begin
  if currShape=nil then exit;
  currShape.QuantQuality:=QuantQuality.Position*ord(UseQSpecChck.Checked);
  RefreshInfo;
end;

procedure TMainFrm.SaveDecodedPicture1Click(Sender: TObject);
begin
  if SaveDecodedDlg.Execute then begin
    Reconst.Picture.Bitmap.SaveToFile(SaveDecodedDlg.FileName);
    WriteLog('Decoded picture and spectrum saved ... :-) RADO.'#13#10);
  end;
end;

procedure TMainFrm.TabSheet6Show(Sender: TObject);
begin
  CoefList.Width:=10;
end;

procedure TMainFrm.Globalstatistics1Click(Sender: TObject);
var StatDlg:TStatForm;
    poms1,poms2:string[15];
    i,j:integer;
    ShapeBoxPts, RoundedShapeBoxPts : integer;
    PSNRSum:real;
    pomb:byte;
    pomi:longword;
begin
  if iPicture=nil then begin
    WriteLog('Error: No picture data available'#13#10);
    exit;
  end;
  StatDlg:=TStatForm.Create(self);
  with StatDlg.StatList do begin
    Clear;
    str(iPicW,poms1); str(iPicH,poms2);
    Items.Add('Picture size: '+poms1+'x'+poms2);
    str(iPicW*iPicH,poms1);
    Items.Add('Pixels in picture: '+poms1);
    ShapeBoxPts:=0; RoundedShapeBoxPts:=0; PSNRSum:=0;
    for i:=0 to ShapeList.Items.Count-1 do begin
      ShapeBoxPts:=ShapeBoxPts+TShape(ShapeList.Items.Objects[i]).RealWidth*
                               TShape(ShapeList.Items.Objects[i]).RealHeight;
      RoundedShapeBoxPts:=RoundedShapeBoxPts+TShape(ShapeList.Items.Objects[i]).Width*
                                             TShape(ShapeList.Items.Objects[i]).Height;
      PSNRSum:=PSNRSum+TShape(ShapeList.Items.Objects[i]).CurrentPSNR;
    end;
    str(ShapeBoxPts,poms1);
    str((100*(ShapeBoxPts-iPicW*iPicH))/ShapeBoxPts:0:2,poms2);
    Items.Add('Pixels in shape windows: '+poms1+' (Slack: '+poms2+'%)');
    str(RoundedShapeBoxPts,poms1);
    str((100*(RoundedShapeBoxPts-iPicW*iPicH))/RoundedShapeBoxPts:0:2,poms2);
    Items.Add('Total pixels processed: '+poms1+' (Slack: '+poms2+'%)');
    str(PSNRSum/ShapeList.Items.Count:0:2,poms1);
    Items.Add('PSNR average [dB]: '+poms1);
    pomi:=0; ShapeBoxPts:=0;
    for i:=0 to iPicH-1 do
      for j:=0 to iPicW-1 do
        if DecFillMap[i*iPicW+j] then begin
          pomb:=Reconst.Picture.Bitmap.Canvas.Pixels[j,i] and 255;
          pomi:=pomi+(integer((integer(iPicture[i*iPicW+j])-integer(pomb)))*(integer(iPicture[i*iPicW+j])-integer(pomb)));
          inc(ShapeBoxPts);
        end;
    if pomi>0 then
      str(10*log10((65025.0*ShapeBoxPts)/pomi):0:2,poms1)
    else poms1:='Not available';
    Items.Add('Global PSNR [dB]: '+poms1);
  end;
  StatDlg.Left:=MainFrm.Left+(MainFrm.Width-StatDlg.Width) div 2;
  StatDlg.Top:=MainFrm.Top+(MainFrm.Height-StatDlg.Height) div 2;
  StatDlg.ShowModal;
  StatDlg.Destroy;
end;

procedure TMainFrm.ZoomSpinChange(Sender: TObject);
begin
  SpecDrawArea.Width:=ZoomSpin.Value*currShape.Width;
  SpecDrawArea.Height:=ZoomSpin.Value*currShape.Height;
end;

procedure TMainFrm.Button1Click(Sender: TObject);
begin
  EncSelForm.Left:=Left+(Width-EncSelForm.Width) div 2;
  EncSelForm.Top:=Top+(Height-EncSelForm.Height) div 2;
  if EncSelForm.ShowModal=mrOK then begin
    EncoderLab.Caption:=EncSelForm.TransName;
  end;
end;

procedure TMainFrm.About1Click(Sender: TObject);
begin
  AboutBox.Left:=Left+(Width-AboutBox.Width) div 2;
  AboutBox.Top:=Top+(Height-AboutBox.Height) div 2;
  AboutBox.ShowModal;
end;

procedure TMainFrm.OpenCompressedPicture1Click(Sender: TObject);
var
  f : TFileStream;
  poms:string[10];
  useCommonConfig : boolean;
  comTransID, comTransModID : longword;
  comQuantQuality, comNormCoef : byte;
  i,j,L,R:integer;
  ValueTable:TList;
  tmpS : TMemoryStream;
  tmpShort : shortint;
  tmpByte : byte;
  tmpWord : word;
  tmpLong : longword;
  TabItems : integer;
  Buffer : longword;
  BfrPtr : byte;
  code : longword;
  a,b : longword;
  s : int64;
  EOBCount : byte;
  TotalRange : longword;
  shapeIDX : integer;

  function ReadBit:longword;
  begin
    if BfrPtr=0 then begin f.Read(Buffer,4); BfrPtr:=32; end;
    Result:=(Buffer shr (BfrPtr-1)) and 1;
    dec(BfrPtr);
  end;

begin
  if iMap=nil then begin MessageDlg('No map loaded. Load Map first',mtError,[mbOK],0); exit end;
  if OpenCompDlg.Execute then begin
    WriteLog('Loading compressed spectrum...');
    f:=TFileStream.Create(OpenCompDlg.Filename,fmOpenRead);

    //check file format id
    SetLength(poms,6); f.Read(poms[1],6);
    WriteLog('...checking file format');
    if (poms<>'SAPF10') and (poms<>'SAPF11') then begin f.Destroy; MessageDlg('Unknown input file format', mtError, [mbOK], 0); exit end;

    //load common config flag
    f.Read(UseCommonConfig,sizeof(useCommonConfig));
    if useCommonConfig then begin
      f.Read(comTransModID, sizeof(comTransModID));
      f.Read(comTransID, sizeof(comTransID));
      f.Read(comQuantQuality, sizeof(comQuantQuality));
      if poms='SAPF11' then f.Read(comNormCoef,1)
      else comNormCoef:=2;
    end;

    WriteLog('...loading data');
    // Restore statistics table from input file
    ValueTable:=TList.Create;
    f.Read(TabItems,sizeof(TabItems));
    for i:=0 to TabItems-1 do begin
      Application.ProcessMessages;
      if i=0 then ValueTable.Add(TWCData.Create(-32768,0,0))
      else if i=1 then ValueTable.Add(TWCData.Create(0,1,1))
      else begin
        f.Read(tmpShort,sizeof(tmpShort));
        if tmpShort=-128 then begin
          f.Read(tmpWord,sizeof(tmpWord));
          j:=integer(-128)-tmpWord;
        end else if tmpShort=127 then begin
          f.Read(tmpWord,sizeof(tmpWord));
          j:=integer(127)+tmpWord;
        end else j:=tmpShort;
        ValueTable.Add(TWCData.Create(TWCData(ValueTable.Items[i-1]).Value+j,j,j));
      end;

      if i=1 then
        f.Read(TWCData(ValueTable.Items[i]).Count,sizeof(TWCData(ValueTable.Items[i]).Count))
      else begin
        f.Read(tmpByte,sizeof(tmpByte));
        if tmpByte=255 then begin
          f.Read(tmpWord,sizeof(tmpWord));
          tmpWord:=tmpWord+255
        end else tmpWord:=tmpByte;
        TWCData(ValueTable.Items[i]).Count:=tmpWord;
      end;
    end;

    //Compute ranges
    TWCData(ValueTable.Items[0]).Range:=0;
    for i:=1 to ValueTable.Count-1 do
      TWCData(ValueTable.Items[i]).Range:=TWCData(ValueTable.Items[i-1]).Range+TWCData(ValueTable.Items[i-1]).Count;

    WriteLog('...decompressing');
    //initialize arithmetic decoder
    a:=0; b:=$FFFFFFFF; BfrPtr:=0; ShapeIDX:=0;
    TotalRange:=TWCData(ValueTable.Items[ValueTable.Count-1]).Range+TWCData(ValueTable.Items[ValueTable.Count-1]).Count;
    tmpS:=TMemoryStream.Create;
    EOBCount:=0;
    f.Read(code,4);
    while (EOBCount<>2) and (tmpS.Position<650000) do begin
      Application.ProcessMessages;
      //Determine current symbol
      s:=int64(b)-a+1;
      tmpLong:=((int64(code)-a+1)*TotalRange -1 ) div s;
      //find symbol in symbol table
      L:=-1; r:=ValueTable.Count;
      j:=(L+R) div 2;
      while (L<R-1) do
        if (j<ValueTable.Count-1) and (TWCData(ValueTable.Items[j+1]).Range<=tmpLong) then begin
          L:=j;
          j:=(L+R) div 2;
        end else if TWCData(ValueTable.Items[j]).Range>tmpLong then begin
          R:=j;
          j:=(L+R) div 2;
        end else begin R:=j; L:=j end;
      j:=R;

      //convert symbol to value and add it to spectrum
      //is it EOB?
      if j<>0 then begin
        //no, it is a normal symbol. put them to temporary stream
        tmpS.Write(TWCData(ValueTable.Items[j]).Value,sizeof(TWCData(ValueTable.Items[j]).Value));
        if j<>1 then EOBCount:=0;
      end else begin
        inc(EOBCount);
        if (EOBCount=1) or (tmpS.Size=0) then begin
          //send current spectrum stream to next shape
          tmpS.Seek(0,soFromBeginning);
          if not useCommonConfig then begin
            tmpS.Read(i,sizeof(i)); comTransModID:=longword(i);
            tmpS.Read(i,sizeof(i)); comTransID:=longword(i);
            tmpS.Read(i,sizeof(i)); comQuantQuality:=i;
            if poms='SAPF11' then begin
              tmpS.Read(i,sizeof(i)); comNormCoef:=i;
            end;
          end;
          TShape(ShapeList.Items.Objects[shapeIDX]).ReadSpectrumStream(tmpS,comTransModID,comTransID,comQuantQuality,comNormCoef);
          if tmpS.Size=0 then EOBCount:=1;
          tmpS.Clear;
          inc(shapeIDX);
        end;
      end;

      //remove symbol from input stream
      if j<ValueTable.Count-1 then
        b:=a + int64(s * TWCData(ValueTable.Items[j+1]).Range) div TotalRange -1;
      a:=a + int64(s * TWCData(ValueTable.Items[j]).Range) div TotalRange;
      while (b and $80000000 = a and $80000000) or ((a and $40000000 = $40000000) and (b and $40000000 = 0)) do
        if (b and $80000000 = a and $80000000) then begin
          a:=a shl 1;
          b:=(b shl 1) or 1;
          code:=(code shl 1) or ReadBit;
        end else if (a and $40000000 <> 0) and (b and $40000000 = 0) then begin
          code:=((code xor $40000000) shl 1) or ReadBit;
          a:=(a and $3fffffff) shl 1;
          b:=((b or $40000000) shl 1) or 1;
        end;
    end;

    //destory structures
    while ValueTable.Count>0 do begin
      TWCData(ValueTable.Items[0]).Destroy;
      ValueTable.Delete(0);
    end;
    ValueTable.Destroy;
    tmpS.Destroy;
    f.Destroy;
    WriteLog('...Done.'#13#10);
  end;
end;

procedure TMainFrm.Clear1Click(Sender: TObject);
begin
  ClearReconstArea;
end;

procedure TMainFrm.Save2Click(Sender: TObject);
begin
  SaveDecodedPicture1.Click;
end;

procedure TMainFrm.Panel1Resize(Sender: TObject);
begin
  Panel3.Width:=Panel1.Width div 3;
  Panel4.Width:=Panel3.Width;
  Panel5.Width:=Panel3.Width;
end;

procedure TMainFrm.WriteLog;
var timeStamp:string[15];
    lines:integer;
begin
  timeStamp:=TimeToStr(Time);
  lines:=Log.Lines.Count;
  Log.Lines.Add('['+timeStamp+'] '+s);
  if Log.Lines.Count=lines then begin
    Log.Lines.Clear;
    Log.Lines.Add('['+timeStamp+'] '+s);
  end;
end;



procedure TMainFrm.RequantBtnClick(Sender: TObject);
var i:integer;
begin
  WriteLog('Requantizing started...');
  for i:=0 to ShapeList.Items.Count-1 do begin
    TShape(ShapeList.Items.Objects[i]).QuantQuality:=QuantQuality.Position*ord(UseQSpecChck.Checked);
    TShape(ShapeList.Items.Objects[i]).NormType:=NormCombo.ItemIndex;
  end;
  WriteLog('...Done.'#13#10);
end;

procedure TMainFrm.SaveLog1Click(Sender: TObject);
begin
  if SaveLogDlg.Execute then
    Log.Lines.SaveToFile(SaveLogDlg.FileName);
end;

procedure TMainFrm.ClearLog1Click(Sender: TObject);
begin
  Log.Clear;
end;

procedure TMainFrm.Generaterectangles1Click(Sender: TObject);
begin
  Generategrid1.Click;
end;

procedure TMainFrm.Generategrid1Click(Sender: TObject);
var poms1,poms2:string[15];
    pomr:TRect;
    x,y,i,j:integer;
    ID:longword;
    tmpShape:TShape;
begin
try
  if iPicture=nil then exit;
  GenRectFrm.Left:=MainFrm.Left+(MainFrm.Width-GenRectFrm.Width) div 2;
  GenRectFrm.Top:=MainFrm.Top+(MainFrm.Height-GenRectFrm.Height) div 2;
  if GenRectFrm.ShowModal=mrOK then begin
    MainFrm.Enabled:=false;
    iMapW:=iPicW;
    iMapH:=iPicH;
    MapDrawArea.Picture.Bitmap.Width:=iMapW;
    MapDrawArea.Picture.Bitmap.Height:=iMapH;
    SetLength(iMap,iMapW*iMapH);
    str(GenRectFrm.XSizeSpin.Value,poms1);
    str(GenRectFrm.YSizeSpin.Value,poms2);
    WriteLog('Generating rectangle map...'#13#10'...adding shapes of size '+poms1+'x'+poms2);
    //Clear draw area
    pomr.Left:=0; pomr.Top:=0; pomr.Right:=iMapW-1; pomr.Bottom:=iMapH-1;
    MapDrawArea.Canvas.Brush.Color:=MapDrawArea.Picture.Bitmap.TransparentColor;
    MapDrawArea.Canvas.FillRect(pomr);
    Application.ProcessMessages;
    //Destroy current shapes
    while ShapeList.Items.Count>0 do begin
      TShape(ShapeList.Items.Objects[0]).Destroy;
      ShapeList.Items.Delete(0);
    end;
    // Generate rectangles
    Map.Picture.Bitmap.PixelFormat:=pf24bit;
    ProgressBar.Position:=0; ProgressBar.Max:=iMapW*iMapH-1; ProgressBar.Show;
    j:=0; ID:=0;
    while j<iMapH do begin
      i:=0;
      while i<iMapW do begin
        tmpShape:=TShape.Create(ID,iPicture,iPicW,iMap,iMapW,i,j);
        tmpShape.Right:=i+GenRectFrm.XSizeSpin.Value-1;
        tmpShape.Bottom:=j+GenRectFrm.YSizeSpin.Value-1;
        tmpShape.PointCount:=GenRectFrm.XSizeSpin.Value*GenRectFrm.YSizeSpin.Value;
        y:=0;
        while (y<GenRectFrm.YSizeSpin.Value) and (j+y<iMapH) do begin
          x:=0;
          while (x<GenRectFrm.XSizeSpin.Value) and (i+x<iMapW) do begin
            Map.Picture.Bitmap.Canvas.Pixels[i+x,j+y]:=ID;
            iMap[(j+y)*iMapW+i+x]:=ID;
            inc(x);
          end;
          inc(y);
        end;
        ProgressBar.Position:=j*iMapW+i;
        str(ID,poms1);
        ShapeList.Items.AddObject('Shape '+poms1,tmpShape);
        inc(ID);
        inc(i,GenRectFrm.XSizeSpin.Value);
      end;
      inc(j,GenRectFrm.YSizeSpin.Value);
      Application.ProcessMessages;
    end;
    ProgressBar.Hide;
    WriteLog('...done.'#13#10);
  end;
finally
  MainFrm.Enabled:=true;
end;
end;

procedure TMainFrm.SaveSpectrumPicture1Click(Sender: TObject);
begin
  if SaveDecodedDlg.Execute then
    SpecDrawArea.Picture.Bitmap.SaveToFile(SaveDecodedDlg.FileName);
end;

procedure TMainFrm.MenuItem1Click(Sender: TObject);
begin
  if SaveDecodedDlg.Execute then
    ViewDrawArea.Picture.Bitmap.SaveToFile(SaveDecodedDlg.FileName);
end;

procedure TMainFrm.SavePicture1Click(Sender: TObject);
begin
  if SaveDecodedDlg.Execute then begin
    Picture.Picture.Bitmap.SaveToFile(SaveDecodedDlg.FileName);
    WriteLog('Picture saved.'#13#10);
  end;
end;

procedure TMainFrm.SaveMap1Click(Sender: TObject);
begin
  if SaveDecodedDlg.Execute then begin
    Map.Picture.Bitmap.SaveToFile(SaveDecodedDlg.FileName);
    WriteLog('Map saved.'#13#10);
  end;
end;

procedure TMainFrm.NormComboChange(Sender: TObject);
begin
  if currShape<>nil then begin
    currShape.NormType:=NormCombo.ItemIndex;
    NormTypeLab.Caption:=NormCombo.Items.Strings[currShape.NormType];
  end;
end;

end.
